package org.yaoqiang.bpmn.model.elements.bpmndi;

import java.util.List;

import org.yaoqiang.bpmn.model.elements.XMLAttribute;
import org.yaoqiang.bpmn.model.elements.XMLComplexElement;
import org.yaoqiang.bpmn.model.elements.XMLElement;

/**
 * BPMNPlane
 * 
 * @author Shi Yaoqiang(shi_yaoqiang@yahoo.com)
 */
public class BPMNPlane extends XMLComplexElement {

	private static final long serialVersionUID = 9170109785031931874L;

	public BPMNPlane(BPMNDiagram parent) {
		super(parent);
	}

	protected void fillStructure() {
		XMLAttribute attrBpmnElement = new XMLAttribute(this, "bpmnElement");
		BPMNShapes refBPMNShapes = new BPMNShapes(this);
		BPMNEdges refBPMNEdges = new BPMNEdges(this);

		add(attrBpmnElement);
		add(refBPMNShapes);
		add(refBPMNEdges);
	}

	public final String getBpmnElement() {
		return get("bpmnElement").toValue();
	}
	
	public final void setBpmnElement(String bpmnElement) {
		set("bpmnElement", bpmnElement);
	}
	
	public final List<XMLElement> getBPMNShapes() {
		return ((BPMNShapes) get("BPMNShapes")).getXMLElements();
	}

	public final List<XMLElement> getBPMNEdges() {
		return ((BPMNEdges) get("BPMNEdges")).getXMLElements();
	}
}
